%% TFG Laura

clear all
close all


%% Definimos las variables
syms a b t T x x0 dx reals
syms  lambda(t)
syms x(t) 
ODE = diff(x, t) == b.*x
p = [a;b];
f=x % f(x,p,t) integrando
dfx=diff(f,x) % parcial x
dfp=[diff(f,a);diff(f,b)] % parcial p


%% PASO 1
% Condicion inicial:
x0=a
% Resolvemos la EDO
sol(t)= dsolve (ODE, x(0) == x0)
sol_p(a,b,t)=sol(t)


%% PASO 2
% restriccion EDO explicita
h_bar=b*x %h_bar(x,p,t)
dh_bar=diff(h_bar,x)

%% implicita h=0
h=dx-h_bar %h(x,dx,p,t)
dhx=diff(h,x)
dhp=[diff(h,a);diff(h,b)]
dhdx=diff(h,dx)

%% EDO para el ADJUNTO
% lambda(t)=multiplicador para la EDO
EDO_adj=dfx+lambda*(dhx-diff(dhdx,t))-diff(lambda,t)*dhdx

%% resolucion simbolica
EDO_a= diff(lambda, t) ==1- b.*lambda

% Condicion final:
lambda_T=0

% Resolvemos
lam(t)= dsolve (EDO_a, lambda(T) == lambda_T)
lam_p(a,b,t)=lam(t)


%% PASO 3
%% restriccion CI g=0
g=x0-a % g(x0,p)=g(x0,a,b)
dgx0=diff(g,x0)
dgp=[diff(g,a);diff(g,b)]

%% variable para cancelar un termino del gradiente
% multiplicadores asociado a cond. iniciales
muu=lam(0)*dhdx/dgx0
% dhdx =1 luego no evaluo. 

integrando=dfp+lam(t).*dhp % verifica: es -lam*x
%% termino integral
comp_1=int(integrando,0,T)
%%
comp_2=muu*dgp
%% Gradiente de F en p
dFp=comp_1+comp_2